/* 
Unlimited Simulator is copyrighted (c) Bruno Barberi Gnecco, 1999, and
distributed under the GNU General Public License (GPL). The conditions can be
found in the file GPL, resident at the main directory of the distribution.
*/
#include "client.h"

int handleEvent ( void ) {
	uint32	key;
	char	buffer[20];
	int	count;

	while (1) {
		mask = ggiEventPoll( vis, emAll, &t);
		if (!mask) return;
		ggiEventRead( ggivis,&ev,emAll );
		switch ( ev.any.type ) {
		  case evExpose:
			render();
		  	break;
			
		  case evKeyPress:
		  case evKeyRepeat:
/***** this will be dealt by the client plugin, but is resting here by now.
Also, hardcoding the keys is horrible */
			switch ( ev.key.label ) {
			  case GII_UCEscape: /* open menu? or quit? */
				break;
			  case 'p': /* pause */
			  case 'P':
				paused = ( paused == True ? False : True );
				break;
			  case 'q': /* quit */
			  case 'Q':
				/* do you really want to quit etc */
				return FATALERROR;
				break;
			  case 's': /* sound on/off */
			  case 'S':
				prefs.sound = ( prefs.sound == True ? False : True );
				break;
			  case 'm': /* map on/off */
			  case 'M':
				break;
			  case GIIK_F1: /* info */
				break;

			  case prefs.keybset.left:	 
				ui.steer.special = True;
				ui.steer.extra = -1;
				break;
			  case prefs.keybset.right:
				ui.steer.touched = True;
				ui.steer.extra = 1;
				break;
			  case prefs.keybset.accel:
				ui.thrust.touched = True;
				break;
			  case prefs.keybset.brake:
				ui.braking.touched = True;
				break;
			  case prefs.keybset.gearup:
				ui.gear.touched = True;
				ui.gear.value = 1;
				break;
			  case prefs.keybset.geardown:
				ui.gear.touched = True;
				ui.gear.value = -1;
				break;
			  case prefs.keybset.clutch:
				ui.clutch.touched = True;
				break;
			}
			break;

		case evKeyRelease:
/**** same here */
			switch ( key ) {
			  case prefs.keybset.left: 
				ui.steer.touched = False;
				break;
			  case prefs.keybset.right:
				ui.steer.touched = False;
				break;
			  case prefs.keybset.accel:
				ui.thrust.touched = False;
				break;
			  case prefs.keybset.brake:
				ui.braking.touched = False;
				break;
			  case prefs.keybset.gearup:
				ui.gear.touched = False;
				ui.gear.value = 0;
				break;
			  case prefs.keybset.geardown:
				ui.gear.touched = False;
				ui.gear.value = 0;
				break;
			  case prefs.keybset.clutch:
				ui.clutch.touched = False;
				break;
			}
			break;
	}
}
